/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/

 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.

 * The Original Code is Rhino code, released
 * May 6, 1999.

 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1997-1999 Netscape Communications Corporation. All
 * Rights Reserved.

 * Contributor(s): 

 * Alternatively, the contents of this file may be used under the
 * terms of the GNU Public License (the "GPL"), in which case the
 * provisions of the GPL are applicable instead of those above.
 * If you wish to allow use of your version of this file only
 * under the terms of the GPL and not to allow others to use your
 * version of this file under the NPL, indicate your decision by
 * deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL.  If you do not delete
 * the provisions above, a recipient may use your version of this
 * file under either the NPL or the GPL.
 */
/**
 * This class implements the String native object.
 *
 * See ECMA 15.5.
 *
 * String methods for dealing with regular expressions are
 * ported directly from C. Latest port is from version 1.40.12.19
 * in the JSFUN13_BRANCH.
 */

#ifndef _JS_NATIVE_STRING_H_
#define _JS_NATIVE_STRING_H_

#include "js-scriptableobject.h"
#include "js-wrapper.h"

/* Classes */
class JSNativeString: public JSScriptableObject, public JSWrapper {
    protected:
	static	const jsString_t	defaultValue;

	jsString_t	string;

    public:
	static	const jsString_t	className;

    protected:
	static	void	finishInit(JSContext *cx, JSScriptable *scope,
				JSFunctionObject *ctor, JSScriptable *proto);
	/* JS methods */
	static	jsVal_t	jsConstructor(JSContext *cx, int numArgs,
				jsVal_t *args, JSFunction *ctorObj,
				jsBool_t inNewExpr);
	static	jsVal_t	jsStaticFunction_fromCharCode(JSContext *cx,
				JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
	static	jsVal_t	jsFunction_charAt(JSContext *cx,
				JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
	static	jsVal_t	jsFunction_charCodeAt(JSContext *cx,
				JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
	static	jsVal_t	jsFunction_indexOf(JSContext *cx,
				JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
	static	jsVal_t	jsFunction_lastIndexOf(JSContext *cx,
				JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
	static	jsVal_t	jsFunction_split(JSContext *cx,
				JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
	static	jsVal_t	jsFunction_substring(JSContext *cx,
				JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
	static	jsVal_t	jsFunction_toLowerCase(JSContext *cx,
				JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
	static	jsVal_t	jsFunction_toUpperCase(JSContext *cx,
				JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
	static	jsVal_t	jsFunction_substr(JSContext *cx,
				JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
	static	jsVal_t	jsFunction_concat(JSContext *cx,
				JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
	static	jsVal_t	jsFunction_slice(JSContext *cx,
				JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
	static	jsVal_t	jsFunction_equals(JSContext *cx,
				JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
	static	jsVal_t	jsFunction_equalsIgnoreCase(JSContext *cx,
				JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
	static	jsVal_t	jsFunction_match(JSContext *cx,
				JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
	static	jsVal_t	jsFunction_search(JSContext *cx,
				JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
	static	jsVal_t	jsFunction_replace(JSContext *cx,
				JSScriptable *thisObj, int numArgs,
				jsVal_t *args, JSFunction *funObj);
	static	int	find_split(JSContext *cx, JSFunction *funObj,
				jsString_t target, jsString_t separator,
				jsVal_t re, int *ip, int *matchlen,
				jsBool_t *matched, jsString_t **parensp,
				int *parensLength);
	static	JSRegExpProxy *
			checkReProxy(JSContext *cx);

	jsVal_t	tagify(JSContext *cx, jsString_t begin, jsString_t end,
			jsString_t value);

    public:
	static	void	defineClass(JSContext *cx, JSScriptable *scope);

	JSNativeString(JSContext *cx, jsString_t string);
	JSNativeString(JSContext *cx);

	/* JS methods */
	jsVal_t	jsFunction_toString(JSContext *cx);
	jsVal_t	jsFunction_valueOf(JSContext *cx);
	jsVal_t	jsFunction_bold(JSContext *cx);
	jsVal_t	jsFunction_italics(JSContext *cx);
	jsVal_t	jsFunction_fixed(JSContext *cx);
	jsVal_t	jsFunction_strike(JSContext *cx);
	jsVal_t	jsFunction_small(JSContext *cx);
	jsVal_t	jsFunction_big(JSContext *cx);
	jsVal_t	jsFunction_blink(JSContext *cx);
	jsVal_t	jsFunction_sup(JSContext *cx);
	jsVal_t	jsFunction_sub(JSContext *cx);
	jsVal_t	jsFunction_fontsize(JSContext *cx, jsString_t value);
	jsVal_t	jsFunction_fontcolor(JSContext *cx, jsString_t value);
	jsVal_t	jsFunction_link(JSContext *cx, jsString_t value);
	jsVal_t	jsFunction_anchor(JSContext *cx, jsString_t value);
	jsBool_t
		jsGet_length(JSContext *cx, jsVal_t *value);

	/* instanceof */
	jsBool_t
		isInstanceOf(const jsString_t className);

	/* scriptable methods */
	jsString_t
		getClassName(JSContext *cx);
	jsBool_t
		get(JSContext *cx, int index, JSScriptable *start,
			jsVal_t *value);
	void	put(JSContext *cx, int index, JSScriptable *start,
			jsVal_t value);

	/* wrap methods */
	jsVal_t	unwrap();

	/* gc methods */
	void	mark(JSContext *cx);
} ;

#endif /* _JS_NATIVE_STRING_H_ */
